/**
 * 
 */
package kazuki;

/**
 * @author kazuki
 *
 */
import java.awt.*;

import javax.swing.*;
import java.awt.event.*;
import javax.swing.table.*;
import java.io.*;
import java.util.*;

import java.util.regex.*;

public class DataTable extends JFrame implements ActionListener
{
	// e[u񐔂Ɠz񐔂IuWFNgz쐬
    Object[] data = new Object[2];
    // ftHgEe[uEf̐錾
    DefaultTableModel dtm;
    // e[u̐錾
    JTable tb;
    // e[u̗
	Object[] columnNames = { "                        (\[g)", "                         (\[g)" };
    // f[^Et@C̍sL^ϐ
    int line_number;
    // t@C`[U̐錾
    JFileChooser fc;
	// I[vt@Cۑϐ
    String dataFileName = null;
	// I[vt@C̃tpXۑϐ
	File dataFilePath = null;
	
	int currentRowNum = 0, newRowNum = 0; //݂ƐVf[^̍sۑϐ

    public DataTable()
    {      	
    	// EBhẼ^Cg
    	//setTitle(" f[^Ee[u̕ҏW");
    	// EBhȄTCY
    	//setSize(500, 400);
    	setBounds(0, 0, 500, 400);
    	// {^AEBhEB
        setDefaultCloseOperation(HIDE_ON_CLOSE);
        // EBhȆ傫ύXs
        setResizable(true);
        // EBhE̕\ꏊK(null=ʒ)
        //setLocationRelativeTo(null);
        //setLocationByPlatform(true);
        //t[ACR̐ݒ
		setIconImage(Toolkit.getDefaultToolkit().getImage("./image/icon2.png"));
		
        try {
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.metal.MetalLookAndFeel");
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.mac.MacLookAndFeel");
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
			//UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this);
		} catch (Exception e) {
			e.printStackTrace();
		}
    	dtm = new DefaultTableModel(columnNames, (line_number));
        tb = new JTable(dtm);
        // s̃\[g{^ݒ
        tb.setAutoCreateRowSorter(true);
        tb.setForeground(Color.black);
        // IZ̃J[
        tb.setSelectionBackground(Color.orange);

    	// XN[e[uɒǉAe[uReiɒǉ
    	// {^plNXĂяoAReiɒǉ
    	getContentPane().add(new JScrollPane(tb));
		getContentPane().add(new ButtonPanel(), BorderLayout.SOUTH);
 		
		//j[o[̐ݒ
		JMenuBar menuBar = new JMenuBar();

		JMenu menu1 = new JMenu("f[^");
		JMenu menu2 = new JMenu("wv");
		JMenu menu3 = new JMenu("f[^Ee[uB");
		
		JMenuItem selectData = new JMenuItem("ʂ̃f[^Et@CJ");
		JMenuItem editData = new JMenuItem("f[^Et@C𒼂ɕҏW  (ҏWɃt@C̍ēǍKv)");
		JMenuItem sortData = new JMenuItem("\[gEf[^̊mF");
		
		JMenuItem readMe = new JMenuItem("wv̕\");
		JMenuItem verInfo = new JMenuItem("o[W");
		
		JMenuItem dtHide = new JMenuItem("e[^Ee[uB");

		selectData.addActionListener(this);
		editData.addActionListener(this);
		sortData.addActionListener(this);
		readMe.addActionListener(this);
		verInfo.addActionListener(this);
		dtHide.addActionListener(this);

		getRootPane().setJMenuBar(menuBar);
		menuBar.add(menu1);
		menuBar.add(menu2);
		menuBar.add(menu3);
		
		menu1.add(selectData);
		menu1.add(editData);
		menu1.add(sortData);
		menu2.add(readMe);
		menu2.add(verInfo);
		menu3.add(dtHide);
		
		selectData.setActionCommand("selectData");
		editData.setActionCommand("editData");
		sortData.setActionCommand("sortData");
		readMe.setActionCommand("readMe");
		verInfo.setActionCommand("verInfo");
		dtHide.setActionCommand("dtHide");

    	// t@C`[U[̍쐬
  		fc = new JFileChooser(".");
  		fc.addChoosableFileFilter(new filter1());
		// FileChooserőIꂽt@CI[v
		selectDataFile();
		
		// EBhE\
		setVisible(true);
    }

    // JFileChooserFileFilter`NX
    class filter1 extends javax.swing.filechooser.FileFilter
    {
    	public boolean accept(File file)
    	{
    		String extension = "";
    		if(file.getPath().lastIndexOf('.') > 0)
    			extension = file.getPath().substring(file.getPath().lastIndexOf('.') + 1).toLowerCase();
    		
    		if(extension != "")
    			return extension.equals("txt");
    		else
    			return file.isDirectory();
    	}
    	
    	public String getDescription()
    	{
    		return "Text Files (*.txt)";
    	}
    }
    public void selectDataFile()	// File Open FileChooserNAf[^Et@CI
    {
    	currentRowNum = dtm.getRowCount();
    	System.out.println("currentRowNum = " + currentRowNum);
    	
    	fc.setDialogTitle("e[uɃ[hf[^Et@CIĊJ");
    	
    	int result = fc.showOpenDialog(DataTable.this);
    		
    		// (APPROVE_OPTION) FileChoooser"J"{^NbNꍇ
    		if (result == JFileChooser.APPROVE_OPTION)
    		{
    			//FileChooserQƂĂfBNgEpX擾ł
    			File directoryName = fc.getCurrentDirectory();
    			System.out.println("directoryName = " + directoryName);
    			//FileChooserőIꂽt@C̃tpX擾ł
    			File filePath = fc.getSelectedFile();
    			System.out.println("filePath = " + filePath);
				dataFilePath = filePath;
				dataFileName = filePath.getName();
    			// Iꂽt@C擾ł
    			System.out.println("dataFileName = " + dataFileName);
    			
    			try {
    					//@Iꂽt@C̃tpXw肷B  					
    					sortLines(filePath);
    					// sortdata.txt̃f[^f[^Ee[uɃ[h
    					loadTableData(filePath);
    					// ]vȗƍsꍇ͍폜
    					deleteOverColRow();
    					System.out.println("current=" + currentRowNum);
    					setTitle("f[^Ee[u̕ҏW     [  " + dataFileName + "  ]");
    					
    				} catch(Exception evt) {}
    		}
    		// (CANCEL_OPTION) FileChoooser""{^NbNꍇ
    		else if(result == JFileChooser.CANCEL_OPTION)
        	{
        		System.out.println("");
        	}
    		
    		// (ERROR_OPTION) FileChoooserŃG[ꍇ
        	else if(result == JFileChooser.ERROR_OPTION)
        	{
        		System.out.println("G[");
        	}
    }

	 public void openDataFile()
	 {
		String str = "notepad.exe " + dataFileName;
		Runtime rt = Runtime.getRuntime();
		try{
		Process pr = rt.exec(str);
		}
		catch(Exception e){}
	}
	 
	 public void openSortFile()
	 {
		String str = "notepad.exe ./sortdata/sortdata.txt";
		Runtime rt = Runtime.getRuntime();
		try{
		Process pr = rt.exec(str);
		}
		catch(Exception e){}
	 }
	 
	 public void openHelp()
	 {
		String str = "notepad.exe ./document/datatable_help.txt";
		Runtime rt = Runtime.getRuntime();
		try{
		Process pr = rt.exec(str);
		}
		catch(Exception e){}
	}
	 
	 public void openVerInfo()
	 {
		 String title = "o[W";
		 String message = "THE DIGITAL WORD BOOK DATA TABLE\nversion 2.0.0\n" +
		 		"Date   : 2010.01.29\n" +
		 		"Author: Kazuki Yamamoto\n" +
		 		"kazuki-y@ka2.so-net.ne.jp";
		 int dialogType = JOptionPane.PLAIN_MESSAGE;
		 dialogType = JOptionPane.INFORMATION_MESSAGE;
		 
		 JOptionPane.showMessageDialog((Component) null,
				 message, title, dialogType);
	 }
	public void actionPerformed(ActionEvent evt)
	{
		if(evt.getActionCommand() == "selectData")
		{
			selectDataFile();
		}	
		if(evt.getActionCommand() == "editData")
		{
			openDataFile();
		}	
		if(evt.getActionCommand() == "sortData")
		{
			openSortFile();
		}
		if(evt.getActionCommand() == "readMe")
		{
			openHelp();
		}
		if(evt.getActionCommand() == "verInfo")
		{
			openVerInfo();
		}
		if(evt.getActionCommand() == "dtHide")
		{
			this.setVisible(false);
		}
	}
	public void sortLines(File dataFileName) throws IOException	//data.txt̍s\[gāAsortdata.txt֏o͂郁\bh
	{		
		BufferedReader br = new BufferedReader(new FileReader(dataFileName));
		//sɂȂ邩킩Ȃ̂,VectorŋLĂ
		Vector v = new Vector();
		String s;
		//1sǂݍŃt@C̏I[ɓBȂ
		while((s=br.readLine())!=null){
		// Vector̍Ōɗvf
		v.addElement(s); }
		// ̓Xg[
		br.close();

    	//Vectorzɕϊ邽߂,̈mۂ
    	String[] lines = new String[v.size()];
    	//Vectorzɕϊ
    	v.copyInto(lines);
    	//\[g
    	Arrays.sort(lines);
    	// f[^Et@C̍sۑ
    	line_number = lines.length;
		try {
				FileOutputStream fos = new FileOutputStream("./sortdata/sortdata.txt");
				OutputStreamWriter osw = new OutputStreamWriter(fos , "MS932");
				BufferedWriter bw = new BufferedWriter(osw);
				String msg  = "\r\n";
				//String msg2  = "\t";
				//bw.write(lines[0]);

   		 		// \[gʂo͂
   		 		for(int i = 0; i < lines.length; i++)
   		 		{
   		 			//System.out.println(lines[i]);
   		 			bw.write(lines[i]);
   		 			bw.write(msg);
   		 		}
   		 		bw.close();
   		 		osw.close();
   		 		fos.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			newRowNum = line_number;
			System.out.println("newRowNum = " + newRowNum);
			
			addMissingRow(); // sĂsǉ
	}
	
    public void loadTableData(File dataFileName) // sortdata.txt̃f[^f[^Ee[uɃ[h
	{
    	//Pattern pattern = Pattern.compile(","); // f[^̋؂蕶w
    	Pattern pattern = Pattern.compile("\t"); // f[^̋؂蕶w
		try 
		{
			final BufferedReader reader = new BufferedReader(new FileReader("./sortdata/sortdata.txt"));
			String line;
			for (int row = 0; (line = reader.readLine()) != null; row++)
				{
				String[] items = pattern.split(line);
				dtm.setRowCount(row + 1);
				for (int column = 0; column < items.length; column++)
				{
					if (dtm.getColumnCount() <= column)
					{
						dtm.setColumnCount(column + 1);
					}
					dtm.setValueAt(items[column], row, column);
				}
			}
			reader.close();
		} catch (IOException e)
		{
			e.printStackTrace();
		}
	} 
    
    public void addMissingRow() // sĂsǉ
    {
    	if(newRowNum > currentRowNum)
    	{
    		dtm.setRowCount(newRowNum);
    	}
    	else
    	{
    		return;
    	}
    }
    public void deleteOverColRow() // f[^Ee[u̗]ȍs폜
    {
    	if(newRowNum < currentRowNum)
    	{
       		dtm.setColumnCount(2); // @\ĂȂ
    		dtm.setRowCount(newRowNum);
    	}
    	else
    	{
    		return;
    	}
    }
    
    public void writeTableData(File dataFileName) // e[uf[^݂̃f[^Et@Cɏo\bh
    {	    
    		try{
				FileWriter fw = new FileWriter(dataFileName);

		        for(int row = 0; row < dtm.getRowCount(); row++)
		        {
		            for(int column = 0; column < 2; column++)
		            {
		            	//f[^e[u̒lt@C֏o
		            	if(column == 0)
		            	{
		            		//fw.write(dtm.getValueAt(row, column) + ",");
		            		fw.write(dtm.getValueAt(row, column) + "\t");
		            	}
		            	else
		            	{
		            		fw.write(dtm.getValueAt(row, column) + "\r\n");
		            	}
		            }
		        }		        
				fw.close();
    			} catch (Exception e) {System.out.println(e);}
    			
    			
    }
    


    class ButtonPanel extends JPanel implements ActionListener	// {^pl쐬ACxgNX
    {
        JButton bt1 = new JButton("f[^̕ۑ"),
        		bt2 = new JButton("f[^̃obNAbv"),
            	bt3 = new JButton("s̒ǉ"),
        		bt4 = new JButton("s̍폜");

        public ButtonPanel()
        {
            add(bt1);
            add(bt2);
            add(bt3);
            add(bt4);

            bt1.addActionListener(this);
            bt2.addActionListener(this);
            bt3.addActionListener(this);
            bt4.addActionListener(this);
            
    		this.setBackground(new Color(6, 92, 165));
        }

        public void actionPerformed(ActionEvent evt)
        {
        	if(evt.getSource() == bt1)
        	{ 	      		
        		try{
        				System.out.println(dataFilePath);
                    	writeTableData(dataFilePath);
                    	sortLines(dataFilePath);
                    	loadTableData(dataFilePath);
                    	
                } catch(Exception e) {}
        	}
        	if(evt.getSource() == bt2)
        	{ 
        		int result = fc.showSaveDialog(DataTable.this);
        		
        		if(result == JFileChooser.APPROVE_OPTION)
        		{
        			File directoryName = fc.getCurrentDirectory();
        			File fileName = fc.getSelectedFile();
        			
        			//System.out.println(fc.getCurrentDirectory());
        			//System.out.println(fileName.getName());
        			
        			try{
        					FileWriter fw = new FileWriter(fileName);
        					//System.out.println(fileName);
        					for(int row = 0; row < dtm.getRowCount(); row++)
        					{
        						for(int column = 0; column < 2; column++)
        						{
        							//f[^e[u̒lt@C֏o
        							if(column == 0)
        							{
        								fw.write(dtm.getValueAt(row, column) + ",");
        							}
        							else
        							{
        								fw.write(dtm.getValueAt(row, column) + "\r\n");
        							}
        						}
        					}		        
        				fw.close();
        				} catch (Exception e) {System.out.println(e);}
        		}
        		else if(result == JFileChooser.CANCEL_OPTION)
        		{
        			System.out.println("LZ܂");
        		}
        		else if(result == JFileChooser.ERROR_OPTION)
        		{
        			System.out.println("G[͎܂");
        		}
        	}
            if(evt.getSource() == bt3)
            {
            	//System.out.println(token_number);
                int numberrows = dtm.getRowCount();
                int numbercolumns = dtm.getColumnCount();
                
                int[] index = tb.getSelectedRows();
                if(index == null || index.length <= 0)
                {
                	dtm.addRow(data);
                }
                else
                {
                	for(int i = 0; i < index.length; i++)
                	{
                		dtm.insertRow(index[i], data);
                		line_number = line_number + 1;
                		//System.out.println(index[i]);
                	}
                }
            }           
        	if(evt.getSource() == bt4)
        	{
        		int numberrows = dtm.getRowCount();
                int numbercolumns = dtm.getColumnCount();
                
        		int[] index = tb.getSelectedRows();
                if(index == null || index.length <= 0)
                {
                	return;
                }                
                else
                {
                	for(int i = 0; i < index.length; i++)
                	{
                		dtm.removeRow(index[i]);
                		line_number = line_number - 1;
                		//System.out.println(index[i]);
                	}
                }
        	}
        }
    }
}
/*    
    // DataTableNXN郁\bh
    public static void main(String args[])
    {
    	DataTable datatable = new DataTable();
    }
*/
